@mixin max-width($max-width: medium) {
  margin-left: auto;
  margin-right: auto;
  width: 95%;

  // @include breakpoint($size-normal) {
  //   width: 92vw;
  // }

  @if $max-width == large {
    max-width: $size-max-width-large;
  }

  @else if $max-width == medium {
    max-width: $size-max-width-normal;
    @include breakpoint($size-large) {
      max-width: $size-max-width-medium;
    }
  }

  @else if $max-width == normal {
    max-width: $size-max-width-small;

    @include breakpoint($size-large) {
      max-width: $size-max-width-normal;
    }
  }

  @else if $max-width == small {
    max-width: $size-max-width-xsmall;

    @include breakpoint($size-large) {
      max-width: $size-max-width-small;
    }
  }

  @else if $max-width == xsmall {
    max-width: $size-max-width-xsmall;
  }

  @else if $max-width == xxsmall {
    max-width: $size-max-width-xxsmall;
  }

  @else if $max-width == null {
    max-width: 100%;
    width: 100%;
    @include breakpoint($size-normal) {
      width: 100%;
    }
    @include breakpoint($size-large) {
      width: 100%;
    }
  }
}

@mixin full-width {
  max-width: 100%;
  margin-left: auto;
  margin-right: auto;
  width: 100%;
}

@mixin input($size: normal) {
  appearance: none;

  &[type=submit] {
    @include button();
  }

  &[type=text],
  &[type=email],
  &[type=password],
  &[type=date] {
    padding: calc(1em - 1px);
    background-color: $color-white;
    border: 1px solid $color-grey;
    border-radius: $border-radius;
    font-weight: 500;
    color: $color-grey-xdark;

    &::placeholder {
      color: $color-grey;
    }

    &:focus {
      border-color: $color-black;
      outline: none;
      background-color: $color-white;

      &::placeholder {
        color: transparent;
      }
    }
  }

  &[type=date] {
    line-height: 1.0;
    background-image: url('../images/icons/calendar.svg');
    background-repeat: no-repeat;
    background-position: calc(100% - .6em) 50%;
    background-size: 1.3em;

    &::-webkit-calendar-picker-indicator {
      display: none;
    }
  }

  @if $size == normal {
    font-size: $font-normal;
  }

  @else if $size == small {
    font-size: $font-small;
  }
}

@mixin button($type: primary, $size: normal) {
  font-weight: 500;
  display: inline-block;
  text-align: center;
  text-decoration: none;
  border-radius: .3rem;
  transition: all $ease-default .25s;

  &:hover,
  &:focus {
    outline: none;
    text-decoration: none;
    background-color: $color-black;
    border-color: $color-black;
    color: $color-white;
  }

  &[disabled],
  &:disabled {
    background-color: $color-grey-xxlight;
    color: $color-grey-light;
    pointer-events: none;

    &:hover, &:focus {
      background-color: $color-grey-xxlight;
      color: $color-grey-light;
    }
  }

  @if $type == primary {
    background-color: $color-red;
    border: 1px solid $color-red;
    color: $color-white;

    &:hover,
    &:focus {
      background-color: $color-black;
      border-color: $color-black;
      color: $color-white;
    }
  }

  @else if $type == secondary {
    color: $color-white;
    background-color: $color-blue;
    border: 1px solid $color-blue;

    a {
      color: $color-white;
    }
    &:hover,
    &:focus {
      a {
        color: $color-white;
      }
    }
  }

  @else if $type == white {
    color: $color-black;
    background-color: $color-white;
    border: 1px solid $color-white;

    &:hover {
      color: $color-white;
      background-color: $color-black;
      border-color: $color-black;
    }
  }

  @else if $type == ghost {
    color: $color-grey-xdark;
    background-color: transparent;
    border: 1px solid $color-grey-xdark;
  }

  @else if $type == ghost-grey {
    color: $color-grey-xdark;
    background-color: transparent;
    border: 1px solid $color-grey-light;
  }

  @else if $type == ghost-white {
    color: $color-white;
    background-color: transparent;
    border: 1px solid $color-white;

    &:hover {
      color: $color-black;
      background-color: $color-white;
    }
  }

  @if $size == normal {
    font-size: $font-xsmall;
    padding: 0.55em 1.3em;
    line-height: 1.2em;

    @include breakpoint($size-large) {
      font-size: $font-small;
    }
  }

  @else if $size == small {
    font-size: $font-xxsmall;
    padding: 0.35em 0.6em;
    line-height: 1.2em;

    @include breakpoint($size-medium) {
      font-size: $font-xsmall;
    }
  }
}

@mixin title($heading: h1) {
  font-weight: 400;
  line-height: 1.23em;
  margin: 0;

  @if $heading == big {
    font-size: $font-xxlarge;

    @include breakpoint($size-normal) {
      font-size: $font-xxxlarge;
    }
  }

  @else if $heading == h1 {
    font-family: $font-secondary;
    font-size: $font-discrete;
    color: $color-blue;

    @include breakpoint($size-medium) {
      font-size: $font-large;
    }

    @include breakpoint($size-normal) {
      font-size: $font-xxlarge;
    }
  }

  @else if $heading == h2 {
    font-family: $font-secondary;
    font-size: $font-discrete;
    line-height: 1.2211em;
    color: $color-blue;
    margin-bottom: .7em;

    @include breakpoint($size-medium) {
      font-size: $font-large;
      margin-bottom: .4em;
    }

    @include breakpoint($size-normal) {
      font-size: $font-xlarge;
      margin-bottom: .4em;
    }
  }

  @else if $heading == h3 {
    color: $color-blue;
    font-size: $font-discrete;
    font-weight: bold;
    margin-bottom: .4em;

    @include breakpoint($size-medium) {
      font-size: $font-large;
    }

    @include breakpoint($size-normal) {
      font-size: $font-xlarge;
    }
  }

  @else if $heading == h4 {
    font-size: $font-medium;

    @include breakpoint($size-normal) {
      font-size: $font-medium;
    }
  }

  @else if $heading == h5 {
    color: $color-black;
    font-size: $font-xsmall;
    letter-spacing: 0.08em;
    text-transform: uppercase;
  }

  @else if $heading == h6 {
    font-size: $font-xsmall;
    letter-spacing: 0.08em;
    text-transform: uppercase;

    @include breakpoint($size-medium) {
      font-size: $font-small;
    }

    @include breakpoint($size-normal) {
      font-size: $font-normal;
    }
  }
}

@mixin pane-title {
  color: $color-red;
  font-size: $font-discrete;
  font-weight: 600;
  line-height: 1.2;
  margin: 0;
  @include breakpoint($size-medium) {
    font-size: $font-xxlarge;
  }
}

@mixin pane-subtitle {
  color: $color-blue;
  font-size: $font-medium;
  line-height: 1.2;
  @include breakpoint($size-medium) {
    font-size: $font-large;
  }
}

@mixin flex($type: full) {
  display: flex;
  flex-wrap: wrap;

  @if $type == full {
    justify-content: stretch;
    align-items: stretch;
    align-content: stretch;

    >* {
      width: 100%;
      margin: 0;
    }
  }
}

@mixin default-margins($margin: 4em) {
  margin-bottom: $margin/2;
  margin-top:  $margin/2;
  @include breakpoint($size-normal) {
    margin-bottom: $margin;
    margin-top: $margin;
  }
}

@mixin placeholder($color) {
  &::-webkit-input-placeholder { /* Chrome/Opera/Safari */
    color: rgba($color, .65);
  }
  &::-moz-placeholder { /* Firefox 19+ */
    color: rgba($color, .65);
  }
  &:-ms-input-placeholder { /* IE 10+ */
    color: rgba($color, .65);
  }
  &:-moz-placeholder { /* Firefox 18- */
    color: rgba($color, .65);
  }
}
